<?php

$class = new IppanelSms();
$template = $class->getTemplateDetails('ClientAreaRegister_clientarea');
$settings = $class->getSettings();	

if(isset($_POST['action']) && $_POST['action'] === 'resendOtp' && $settings['enable_otp'] == 1):

	$class->debug('resendOtp - '.date('Y/m/d H:i:s'),null, 'otpActionHook.txt');

	//Update the OTP and Request.
	$otp_id = $_POST['otp_id'];
	$otp_req = $class->getOtp( $otp_id );
	$delaytime = time()-strtotime($otp_req['datetime']);
	if ($delaytime < $settings['otpdelay']) {
		$allowedtime = $settings['otpdelay'] - $delaytime;
		echo json_encode(['code' => 0 , 'message' => 'کد تأیید به تازگی برای شما ارسال شده است. شما می توانید بعد از '.$allowedtime.' ثانیه اقدام به درخواست مجدد کد تأیید نمایید.', 'data' => []]);
	exit;
	  
	} 
	//Regenerate the OTP and Request and Save
	$new_otp = $class->randomString($settings['otplength'] , true);
	$new_request = $class->randomString(20);

	//Client Info
	$client_query = $class->getClientDetailsByClientId($settings, $otp_req['relid'] ,false);
	$client = mysql_fetch_array( $client_query , MYSQL_ASSOC);
	
	$message = str_replace(['{firstname}' , '{lastname}' , '{otp}' , '{request}'] , [$client['firstname'], $client['lastname'] , $new_otp , $new_request] , $template['template']);
	
	update_query( "mod_ippanelsms_otp", array("otp" => $new_otp, "request" => $new_request, "text" => $message,"status" => "0", "datetime" => date("Y-m-d H:i:s")), array( "id" => $otp_id ) );
	$class->addLog("OTP Updated");

	//Send The OTP:
	$class->setUserid( $client['id'] );
	$class->setPosition('OTP Resend');
	$class->setGsmnumber( $client['gsmnumber'] );
	$class->setMessage( $message );
	$class->send();
	
	update_query( "mod_ippanelsms_otp", array( "status" => "1"), array( "id" => $otp_id ) );
	$class->addLog("OTP sent.");
		
	echo json_encode(['code' => 1 , 'message' => 'پیامک کد تأیید جدید به شماره ' . $client['gsmnumber'] . ' ارسال شد.', 'data' => []]);
	exit;
endif;

if(isset($_POST['action']) && $_POST['action'] === 'otpVerification' && $settings['enable_otp'] == 1):
	$class->debug('otpVerification - '.date('Y/m/d H:i:s'),null, 'otpActionHook.txt');
		
	//echo json_encode(['id' => $_POST['otp_id']]);
	$user_otp = $_POST['otp'];
	$otp_id = $_POST['otp_id'];
	//Lets Comprate and Validate the OTP Provided by the User,
	//Once its set then, update the OTP Status
	$otp_data = $class->getOtp( $otp_id );	
	
	
	if($user_otp === $otp_data['otp']):
		
		//When OTP is Verified, update the database and set status to 2.
		update_query( "mod_ippanelsms_otp", array( "status" => "2"), array( "id" => $otp_id ) );

		echo json_encode(['code' => 1 , 'message' => 'شماره موبایل شما تأیید شد.' , 'data' => []]);
		exit;
	endif;	
	
	echo json_encode(['code' => 0 , 'message' => 'کد تأیید وارد شده صحیح نیست.' , 'data' => []]);
	exit;
	
endif;


//Action Hooks.

add_hook('AdminAreaClientSummaryPage', 1, function($vars) { // صفحه پروفایل کاربر در مدیریت 
	
	$class = new ippanelSms();
	$settings = $class->getSettings();
	$class->debug('AdminAreaClientSummaryPage - '.date('Y/m/d H:i:s'),null, 'otpActionHook.txt');
	//Now if OTP is verified, show that in tha ADMIN
	$user_id = $vars['userid'];
	if($user_id && $settings['enable_otp'] == 1):
		$output = '<div class="clientsummaryactions">تأييد شماره موبایل: <span id="taxstatus" class="csajaxtoggle"><strong class="textgreen">';
		$otp = $class->getClientOTP( $user_id );
		$userDetails = mysql_fetch_array($class->getClientDetailsByClientId($settings, $user_id ,false) , MYSQL_ASSOC);
		if(count($otp)) {
			foreach($otp as $key => $value):
				if($class->util_gsmnumber($userDetails['gsmnumber']) === $class->util_gsmnumber($value['phonenumber'])):
					if($value['status'] == 2):
						$output .=  'بله';
					else: // کد تایید ارسال نشده است
						$output .=  'خير';						
					endif;
				else: // وقتی شماره موبایل مشتری با شماره موبایل جدول کد تایید یکی نیست
					$output .=  'یکسان نیست';						
				endif;
			endforeach;
		} else { // موبایل برای تایید وارد نشده است
			$output .= 'وارد نشده';						
		}	
		$output .= '</strong></span></div>';
		return $output;
	endif;
});



	
add_hook('ClientAreaHeadOutput', 1, function($vars) {
	$class = new ippanelSms();
	$settings = $class->getSettings();
	if($settings['enable_otp'] == 1) return '<link rel="stylesheet" href="modules/addons/ippanel_sms/assets/css/sweetalert.min.css" />
			<script src="modules/addons/ippanel_sms/assets/js/sweetalert.min.js"></script>
			<script type="text/javascript" src="modules/addons/ippanel_sms/assets/js/bootbox.min.js"></script>';
});


add_hook('ClientAreaHeaderOutput', 1, function($vars) { // نمایش فرم تایید موبایل در بخش کاربری
	$return = '';
	//Look For Unverified.
	$class = new IppanelSms();
	$settings = $class->getSettings();
	if (!$class->checkSettings($settings)  || $settings['enable_otp'] !== 1) {
		return null;
	}

	$popup_otp = 1;
	$class->debug('ClientAreaHeaderOutput - '.date('Y/m/d H:i:s'),null, 'otpActionHook.txt');
$class->debug($vars['templatefile'],null, 'otpcheck.txt');
	if(isset($vars['client'])):

		$unverified_otp_data = $class->getUnverifiedOTP( $vars['client']->id );
		//Lets Verify the Present Phone Number
		$_otp_data = [];
		$client = $class->getClientDetailsByclientId($settings, $vars['client']->id,false);


        $num_rows = mysql_num_rows($client);
        if ($num_rows == 1) {
			$UserInformation = mysql_fetch_assoc($client);
			$settings['access'] = json_decode($settings['accesswithoutverify'],true);
			if(is_null($unverified_otp_data) || (is_array($unverified_otp_data) && count($unverified_otp_data))){
				$accessTypes = $class->getAccessTypes();
				if($vars['templatefile'] == 'clientareahome'){
					$popup_otp = 1;
				}elseif(in_array($vars['templatefile'] , array('supportticketsubmit-confirm','viewticket')) && in_array('supportticketsubmit-steptwo' ,$settings['access'])){

					$popup_otp = 0;
				} elseif (in_array($vars['templatefile'] ,$settings['access']) && $settings['access'][$vars['templatefile']]) {
					$popup_otp = 0;
					// echo 1;
					// exit;
				} else {
					header('location:clientarea.php?accesslimited=1');
					exit;
				}
			}
			if($popup_otp){
			if(is_array($unverified_otp_data) && count($unverified_otp_data)){ //اگر موبایل تایید نشده داشت
				foreach($unverified_otp_data as $key => $value):
					
					//Match the Phone Number with clients Existing.
					if($class->util_gsmnumber($value['phonenumber']) === $class->util_gsmnumber($UserInformation['gsmnumber'])):
						$_otp_data = $value;
					endif;
									
				endforeach;
		
		
				$return = '
				<!-- Trigger the modal with a button -->
						<!-- Modal -->
						<form method="post" class="using-password-strength" action="" onSubmit="return checkOtpForm(this);" role="form" name="otpVerification" id="frmOtpVerification">
							<input type="hidden" name="action" value="otpVerification">
							<input type="hidden" name="otp_id" value="' . $_otp_data['id'] . '">
							<div id="hook-modal" class="modal fade" role="dialog">
							  <div class="modal-dialog">
							
								<!-- Modal content-->
								<div class="modal-content">
								  <div class="modal-header">
									<button type="button" class="close" data-dismiss="modal">&times;</button>
									<h4 class="modal-title">کد تأييد</h4>
									<p>لطفاً کد ارسال شده به شماره ' . $_otp_data['phonenumber'] . ' را وارد نماييد.</p>';
				if(isset($_GET['accesslimited'])) $return .= '<div class="alert alert-danger">دسترسی شما تا وقتی که کد تأیید را وارد نمایید محدود می باشد.</div>';
				$return .= '		 
								 </div>
								  <div class="modal-body">
									<div class="form-group">
										<label for="otp">کد تأييد را وارد نماييد:</label>
										<input type="text" name="otp" class="form-control" id="otp" autocomplete="off">
									</div>
								  </div>
								  <div class="modal-footer">
									<button type="submit" class="btn btn-primary">ارسال</button>
									<button type="button" class="btn btn-default" data-dismiss="modal">بستن</button>
									<hr />
									<p class="text-center margin-10">
										<button type="button" class="btn btn-primary" id="resend-otp">ارسال مجدد کد</button>
									</p>
								  </div>
								</div>
							
							  </div>
							</div>
						</form>';
			} elseif( is_null($unverified_otp_data)) { // اگر هیچ موبایلی وارد نشده بود
				$template = $class->getTemplateDetails('ClientAreaRegister_clientarea');
				if ($template['active'] == 0) {
					return null;
				}
				
				$template['variables'] = str_replace(" ", "", $template['variables']);
				$replacefrom = explode(",", $template['variables']);
				$otp = $class->randomString($settings['otplength'] , true);
				$request = $class->randomString(20);
				$replaceto = array(
				$UserInformation['firstname'],
				$UserInformation['lastname'],
				$otp,
				$request,
				$UserInformation['id'],
				$UserInformation['email'],
				$UserInformation['companyname'],
				$UserInformation['city'],
				$UserInformation['state'],		    
			);
				$message = str_replace($replacefrom, $replaceto, $template['template']);
				$message = $class->extraVars($message);
				$class->setGsmnumber($UserInformation['gsmnumber']);
				$class->setUserid($UserInformation['id']);
				$class->setPosition('Client area OTP Sms');
				$class->setMessage($message);
			//Insert the OTP
			$values = array(
				"otp" => $otp,
				"type" => 'client',
				"relid" => $UserInformation['id'],
				"request" => $request,
				"text" => $message,
				"status" => 0,
				"datetime" => date("Y-m-d H:i:s"),
				"phonenumber" => $UserInformation['gsmnumber']
			);
			
			$otp_id = insert_query('mod_ippanelsms_otp', $values);
			$class->addLog("OTP saved to the database");		
			$class->send();
			//status => 0 //Default	
			//status => 1 //Sent
			//status => 2 //confirmed
			//status => 3 //EMPTY
			update_query( "mod_ippanelsms_otp", array( "status" => "1"), array( "id" => $otp_id ) );
			$class->addLog("OTP sent.");

		
		
				$return = '<!-- Trigger the modal with a button -->
						<!-- Modal -->
						<form method="post" class="using-password-strength" action="" onSubmit="return checkOtpForm(this);" role="form" name="otpVerification" id="frmOtpVerification">
							<input type="hidden" name="action" value="otpVerification">
							<input type="hidden" name="otp_id" value="' . $otp_id . '">
							<div id="hook-modal" class="modal fade" role="dialog">
							  <div class="modal-dialog">
							
								<!-- Modal content-->
								<div class="modal-content">
								  <div class="modal-header">
									<button type="button" class="close" data-dismiss="modal">&times;</button>
									<h4 class="modal-title">کد تأييد</h4>
									<p>لطفاً کد ارسال شده به شماره ' . $UserInformation['gsmnumber'] . ' را وارد نماييد.--</p>
								  </div>
								  <div class="modal-body">
									<div class="form-group">
										<label for="otp">کد تأييد را وارد نماييد:</label>
										<input type="text" name="otp" class="form-control" id="otp" autocomplete="off">
									</div>
								  </div>
								  <div class="modal-footer">
									<button type="submit" class="btn btn-primary">ارسال</button>
									<button type="button" class="btn btn-default" data-dismiss="modal">بستن</button>
									<hr />
									<p class="text-center margin-10">
										<button type="button" class="btn btn-primary" id="resend-otp">ارسال مجدد کد</button>
									</p>
								  </div>
								</div>
							
							  </div>
							</div>
						</form>';
			}
			}
		}
	endif;

	return $return;
});


add_hook('ClientAreaFooterOutput', 1, function($vars) {
		$class = new ippanelSms();
	$settings = $class->getSettings();
	if($settings['enable_otp'] == 1) {
	  $return = '<script type="text/javascript">
					  $(window).on(\'load\',function(){
						  $(\'#hook-modal\').modal(\'show\');
					  });
					  
					  $("#resend-otp").click(function(e){

							  $.ajax({
									  url: \'clientarea.php\',
									  type: \'post\',
									  data: {"otp_id": $("input[name=otp_id]").val()  , "action":"resendOtp" },
									  //async: false,
									  beforeSend: function () {
										  //Can we add anything here.
									  },
									  cache: false,
									  dataType: \'json\',
									  crossDomain: true,
									  success: function (data) {
										  if (data.code == 1) {
											  
											  swal({
													  title: "ارسال شد",
													  text: data.message,
													  type: "success"
												  }, function() {
													  window.location = "clientarea.php";
												  });
											  
										  } else {
											  bootbox.alert(data.message);
										  }
									  },
									  error: function (data) {
										  console.log(\'Error:\', data);
									  }
								  });
							  

					  });
					  
					  function checkOtpForm(elements) {
						  
						  if(elements.otp.value == \'\') {
							  bootbox.alert("لطفا کد تأييد را وارد کنيد");
							  elements.otp.focus();
						  } else {
							  
							  $.ajax({
									  url: \'clientarea.php\',
									  type: \'post\',
									  data: $(elements).serialize(),
									  //async: false,
									  beforeSend: function () {
										  //Can we add anything here.
									  },
									  cache: true,
									  dataType: \'json\',
									  crossDomain: true,
									  success: function (data) {
										  console.log(data);
										  if (data.code == 1) {
											  
											  swal({
													  title: "تأیید شد!",
													  text: data.message,
													  type: "success"
												  }, function() {
													  window.location = "clientarea.php";
												  });
											  
										  } else {
											  bootbox.alert(data.message);
										  }
									  },
									  error: function (data) {
										  console.log(\'Error:\', data);
									  }
								  });
							  
							  
						  }
						  
						  return false;
					  }
					  
				  </script>';
	return $return;			
	}	
});


add_hook('ClientEdit', 1, function($vars) {
    // Perform hook code here...
/*
    $class = new IppanelSms();
    $template = $class->getTemplateDetails('ClientAreaRegister_clientarea');
    if ($template['active'] == 0) {
        return null;
    }

    $settings = $class->getSettings();
    if (!$class->checkSettings($settings)) {
        return null;
    }
    $oldmobile = $vars['olddata']['customfields'.$settings['gsmnumberfield']];
    $newmobile = $vars['customfields'.$settings['gsmnumberfield']];
    if($oldmobile !== $newmobile){
        $class->debug('otpActionHook - '.date('Y/m/d H:i:s'),null, 'otpActionHook.txt');
        $client = $class->getClientDetailsByclientId($settings, $vars['userid'],false);
        $num_rows = mysql_num_rows($client);
        if ($num_rows == 1) {
            $UserInformation = mysql_fetch_assoc($client);
            $template['variables'] = str_replace(" ", "", $template['variables']);
            $replacefrom = explode(",", $template['variables']);
			$otp = $class->randomString(6 , true);
			$request = $class->randomString(20);
			$replaceto = array(
    			$UserInformation['firstname'],
    			$UserInformation['lastname'],
    			$otp,
    			$request,
    			$vars['userid'],
    			$vars['email'],
    			$UserInformation['companyname'],
    			$UserInformation['city'],
    			$UserInformation['state'],		    
    	    );
            $message = str_replace($replacefrom, $replaceto, $template['template']);
	        $message = $class->extraVars($message);
            $class->setGsmnumber($newmobile);
            $class->setUserid($vars['userid']);
            $class->setPosition('Client area OTP Sms');
            $class->setMessage($message);
		    $sql = "DELETE FROM mod_ippanelsms_otp WHERE relid = '".$vars['userid']."}';";
            mysql_query($sql);
    		//Insert the OTP
    		$values = array(
    			"otp" => $otp,
    			"type" => 'client',
    			"relid" => $vars['userid'],
    			"request" => $request,
    			"text" => $message,
    			"status" => 0,
    			"datetime" => date("Y-m-d H:i:s"),
    			"phonenumber" => $newmobile
    		);

    		$otp_id = insert_query('mod_ippanelsms_otp', $values);
    		$class->addLog("OTP saved to the database");		
    		$class->send();
    		//status => 0 //Default	
    		//status => 1 //Sent
    		//status => 2 //confirmed
    		//status => 3 //EMPTY
    		update_query( "mod_ippanelsms_otp", array( "status" => "1"), array( "id" => $otp_id ) );
    		$class->addLog("OTP sent.");		
	    }	
    }*/
});

/*
add_hook('ClientAdd', 1, function($vars) {
    // Perform hook code here...
});
*/